import hosties.hosties as hosties, playerlib, gamethread, es

LR = hosties.RegisterLastRequest('chickenfight')
sv = es.ServerVar

class ChickenFight(object):
	def __init__(self):
		self.t = None
		self.ct = None

	def end(self):
		self.t = self.ct = None
		gamethread.cancelDelayed('Jump Check Loop')

	def start(self, t, ct):
		self.t = t
		self.ct = ct

		hosties.HM.msg('CF1', {'t': es.getplayername(t), 'ct': es.getplayername(ct)})
		hosties.HM.msg('CF2')
		hosties.HM.msg('CF3')

		if int(sv('hosties_enable_chicken_fight_won')):
			self.jumpCheckLoop()

	def jumpCheckLoop(self):
		gamethread.delayedname(0.1, 'Jump Check Loop', self.jumpCheckLoop)
		for userid in [self.t, self.ct]:
			if self.checkOnHead(userid):
				return

	def checkOnHead(self, userid):
		if userid in [self.t, self.ct]:
			if playerlib.getPlayer(self.t).get('distance', [self.ct, 'xy']) <= 40 and 180 >= playerlib.getPlayer(self.t).get('distance', [self.ct, 'z']) >= 60:
				LR.stopLR(self.t, 'lost chicken fight', {'player': es.getplayername(self.ct)})
				return True

			if playerlib.getPlayer(self.t).get('distance', [self.ct, 'xy']) <= 40 and 180 >= playerlib.getPlayer(self.ct).get('distance', [self.t, 'z']) >= 60:
				LR.stopLR(self.ct, 'lost chicken fight', {'player': es.getplayername(self.t)})
				return True

	def player_death(self, userid, attacker, weapon):
		if userid in [self.t, self.ct] and attacker in [self.t, self.ct]:
			return
		hosties.getPlayer(attacker).checkKill(userid, weapon)

CF = ChickenFight()

def player_death(ev):
	CF.player_death(int(ev['userid']), int(ev['attacker']), ev['weapon'])

LR.registerStartFunction(CF.start)
LR.registerEndFunction(CF.end)
